/*
	D&D Thingy
	(c) 2004-2005 madalien.com

	author:
		DaF ( daf.public@madalien.com )

	description:
		This application purpose is to "role the dice" so you
		can create a D&D game character.

		See the readme.txt for more information...

	licence:
		This code is licence under the GPL, please see gpl.txt or
		http://www.gnu.org/licenses/gpl.html for the details.
 */


using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DndThingy
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		#region Form Designer Control Variables
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label0;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.ComboBox cmbList;
		private System.Windows.Forms.Panel pnlSelect;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem menuStatsExit;
		private System.Windows.Forms.MenuItem menuStatsSep;
		private System.Windows.Forms.MenuItem menuStatsRestart;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.MenuItem menuHelpAbout;
		private System.Windows.Forms.MenuItem menuStats;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		#endregion

		private TextBox[] txtStats = new TextBox[6];
		private int statCount = 0;

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label0 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.pnlSelect = new System.Windows.Forms.Panel();
			this.btnOk = new System.Windows.Forms.Button();
			this.cmbList = new System.Windows.Forms.ComboBox();
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.menuStats = new System.Windows.Forms.MenuItem();
			this.menuStatsRestart = new System.Windows.Forms.MenuItem();
			this.menuStatsSep = new System.Windows.Forms.MenuItem();
			this.menuStatsExit = new System.Windows.Forms.MenuItem();
			this.menuHelp = new System.Windows.Forms.MenuItem();
			this.menuHelpAbout = new System.Windows.Forms.MenuItem();
			this.pnlSelect.SuspendLayout();
			this.SuspendLayout();
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.Location = new System.Drawing.Point(8, 10);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(40, 15);
			this.label5.TabIndex = 0;
			this.label5.Text = "STR";
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label6.Location = new System.Drawing.Point(8, 52);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(40, 15);
			this.label6.TabIndex = 1;
			this.label6.Text = "DEX";
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label7.Location = new System.Drawing.Point(8, 92);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(40, 15);
			this.label7.TabIndex = 2;
			this.label7.Text = "CHA";
			// 
			// label8
			// 
			this.label8.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label8.Location = new System.Drawing.Point(8, 132);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(40, 15);
			this.label8.TabIndex = 3;
			this.label8.Text = "CON";
			// 
			// label9
			// 
			this.label9.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label9.Location = new System.Drawing.Point(8, 172);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(40, 15);
			this.label9.TabIndex = 4;
			this.label9.Text = "WIS";
			// 
			// label10
			// 
			this.label10.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label10.Location = new System.Drawing.Point(8, 212);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(40, 15);
			this.label10.TabIndex = 5;
			this.label10.Text = "INT";
			// 
			// label0
			// 
			this.label0.BackColor = System.Drawing.Color.Black;
			this.label0.Location = new System.Drawing.Point(8, 40);
			this.label0.Name = "label0";
			this.label0.Size = new System.Drawing.Size(136, 2);
			this.label0.TabIndex = 14;
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.Color.Black;
			this.label1.Location = new System.Drawing.Point(8, 80);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(136, 2);
			this.label1.TabIndex = 15;
			// 
			// label2
			// 
			this.label2.BackColor = System.Drawing.Color.Black;
			this.label2.Location = new System.Drawing.Point(8, 120);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(136, 2);
			this.label2.TabIndex = 16;
			// 
			// label3
			// 
			this.label3.BackColor = System.Drawing.Color.Black;
			this.label3.Location = new System.Drawing.Point(8, 160);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(136, 2);
			this.label3.TabIndex = 17;
			// 
			// label4
			// 
			this.label4.BackColor = System.Drawing.Color.Black;
			this.label4.Location = new System.Drawing.Point(8, 200);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(136, 2);
			this.label4.TabIndex = 18;
			// 
			// pnlSelect
			// 
			this.pnlSelect.BackColor = System.Drawing.SystemColors.Control;
			this.pnlSelect.Controls.Add(this.btnOk);
			this.pnlSelect.Controls.Add(this.cmbList);
			this.pnlSelect.Location = new System.Drawing.Point(56, 8);
			this.pnlSelect.Name = "pnlSelect";
			this.pnlSelect.Size = new System.Drawing.Size(90, 24);
			this.pnlSelect.TabIndex = 19;
			// 
			// btnOk
			// 
			this.btnOk.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOk.Location = new System.Drawing.Point(56, 2);
			this.btnOk.Name = "btnOk";
			this.btnOk.Size = new System.Drawing.Size(32, 21);
			this.btnOk.TabIndex = 15;
			this.btnOk.Text = "ok";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// cmbList
			// 
			this.cmbList.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbList.Location = new System.Drawing.Point(0, 2);
			this.cmbList.Name = "cmbList";
			this.cmbList.Size = new System.Drawing.Size(52, 21);
			this.cmbList.TabIndex = 14;
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuStats,
																					 this.menuHelp});
			// 
			// menuStats
			// 
			this.menuStats.Index = 0;
			this.menuStats.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuStatsRestart,
																					  this.menuStatsSep,
																					  this.menuStatsExit});
			this.menuStats.Text = "&Stats";
			// 
			// menuStatsRestart
			// 
			this.menuStatsRestart.Index = 0;
			this.menuStatsRestart.Shortcut = System.Windows.Forms.Shortcut.CtrlR;
			this.menuStatsRestart.Text = "Restart";
			this.menuStatsRestart.Click += new System.EventHandler(this.menuStatsRestart_Click);
			// 
			// menuStatsSep
			// 
			this.menuStatsSep.Index = 1;
			this.menuStatsSep.Text = "-";
			// 
			// menuStatsExit
			// 
			this.menuStatsExit.Index = 2;
			this.menuStatsExit.Shortcut = System.Windows.Forms.Shortcut.AltF4;
			this.menuStatsExit.Text = "E&xit";
			this.menuStatsExit.Click += new System.EventHandler(this.menuStatsExit_Click);
			// 
			// menuHelp
			// 
			this.menuHelp.Index = 1;
			this.menuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuHelpAbout});
			this.menuHelp.Text = "&Help";
			// 
			// menuHelpAbout
			// 
			this.menuHelpAbout.Index = 0;
			this.menuHelpAbout.Shortcut = System.Windows.Forms.Shortcut.F1;
			this.menuHelpAbout.Text = "&About...";
			this.menuHelpAbout.Click += new System.EventHandler(this.menuHelpAbout_Click);
			// 
			// frmMain
			// 
			this.AcceptButton = this.btnOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(152, 243);
			this.Controls.Add(this.pnlSelect);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.label0);
			this.Controls.Add(this.label10);
			this.Controls.Add(this.label9);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.label5);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Menu = this.mainMenu;
			this.MinimizeBox = false;
			this.Name = "frmMain";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "D&D Thingy";
			this.Load += new System.EventHandler(this.frmMain_Load);
			this.pnlSelect.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.EnableVisualStyles();
			Application.Run(new frmMain());
		}

		private void AddTextBoxStat(int index)
		{
			txtStats[index].Text = cmbList.SelectedItem.ToString();
			txtStats[index].Top = pnlSelect.Top + 2;
			this.Controls.Add(txtStats[index]);
		}

		private void frmMain_Load(object sender, System.EventArgs e)
		{
			// Random Number generator
			Random rdm = new Random();

            // Creates the array of textBoxes with default properties
			for (int i = 0; i < txtStats.Length; i++)
			{
				txtStats[i] = new TextBox();
                
				txtStats[i].Left = 56;
				txtStats[i].MaxLength = 2;
				txtStats[i].ReadOnly = true;
				txtStats[i].Size = new System.Drawing.Size(88, 20);
				txtStats[i].TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
				txtStats[i].Text = "";
			
				// Piggy back ride to generate the numbers
				cmbList.Items.Add(rdm.Next(3,17));
			}
			// Selects the first item on the list
			cmbList.SelectedIndex = 0;
		}

		private void btnOk_Click(object sender, System.EventArgs e)
		{
			// Skips if no value is selected
			if(cmbList.SelectedIndex == -1) return;

			this.SuspendLayout();

			AddTextBoxStat(statCount);

			// Removes the used value
			cmbList.Items.RemoveAt(cmbList.SelectedIndex);
			cmbList.SelectedIndex = 0;

			pnlSelect.Top += 40;

			if(statCount == 4)
			{
				AddTextBoxStat(statCount+1);
				pnlSelect.Hide();
			}

			statCount++;
			this.ResumeLayout();
		}

		private void menuStatsExit_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void menuStatsRestart_Click(object sender, System.EventArgs e)
		{
			for (int i = 0; i < txtStats.Length; i++)
			{
				this.Controls.Remove(txtStats[i]);
			}
			pnlSelect.Top = 8;
			pnlSelect.Visible = true;
			cmbList.Items.Clear();
			statCount = 0;

			this.frmMain_Load(sender, e);
		}

		private void menuHelpAbout_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show(this, "D&D Thingy v" + Application.ProductVersion.ToString()
				+  " by Daffy.\nEat your heart out Sylver :p", "About...", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}
	}
}
